> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/xamarin/guides/viewer-components/user-bookmarks-a.md).

# User-defined bookmarks in Xamarin

Learn how to manage user-defined bookmarks in Xamarin.Android with this tutorial. Create, import, export, and navigate PDF bookmarks efficiently. The Apryse Xamarin SDK streamlines secure, serverless

{% hint style="info" %}
**This tutorial only applies to Xamarin.Android. See Xamarin.iOS equivalent here .**
{% endhint %}

{% hint style="warning" %}
**User-defined bookmarks are an Apryse specific feature that may not show in other PDF viewer applications. If you want to manage PDF bookmarks so that they can be processed in other standard PDF viewers, see the document outline guide .**
{% endhint %}

The [`UserBookmarkDialogFragment`](https://sdk.apryse.com/api/xamarinandroid/tools/api/pdftron.PDF.Controls.UserBookmarkDialogFragment.html) displays a list of user-defined bookmarks that can be used to navigate the document.

![](https://653871032-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FgjsBtuYmcKhWOdM9VCg4%2Fuploads%2Fgit-blob-222550db548264bb533adae814bf9d6384f373d4%2F5e833372cc4a34933785e770242e543aa74a3e74-1080x2160.png?alt=media)

## Show user bookmark dialog

To show a user bookmark dialog fragment in your activity, create a new instance of [`UserBookmarkDialogFragment`](https://sdk.apryse.com/api/xamarinandroid/tools/api/pdftron.PDF.Controls.UserBookmarkDialogFragment.html) by calling `newInstance()` and setting the [`PDFViewCtrl`](https://sdk.apryse.com/api/xamarinandroid/pdfnet/api/pdftron.PDF.PDFViewCtrl.html):

{% tabs %}
{% tab title="C#" %}
{% code lineNumbers="true" %}

```csharp
fun showBookmarksDialog(fragmentManager: FragmentManager, pdfViewCtrl: PDFViewCtrl): BookmarksDialogFragment {
    var bookmarksDialog = pdftron.PDF.Dialog.BookmarksDialogFragment.NewInstance();
    bookmarksDialog.SetPdfViewCtrl(pdfViewCtrl);
    List<DialogFragmentTab> tabs = new List<DialogFragmentTab>();
    var userBookmarksDialog = new DialogFragmentTab(
        Java.Lang.Class.FromType(typeof(UserBookmarkDialogFragment)), BookmarksTabLayout.TagTabBookmark, null, "User Bookmarks", "Bookmarks Dialog", null);
    tabs.Add(userBookmarksDialog);
    bookmarksDialog.SetDialogFragmentTabs(tabs);
    bookmarksDialog.SetStyle((int)DialogFragmentStyle.NoTitle, Resource.Style.PDFTronAppTheme);
    bookmarksDialog.Show(fragmentManager, "bookmarks_dialog");
    return bookmarksDialog;
}
```

{% endcode %}
{% endtab %}
{% endtabs %}

## Listener

You can set a listener to be notified when a user bookmark is clicked by calling `setUserBookmarkListener(UserBookmarkDialogListener)`.

## Read-only

If the document has write access, users can add new user bookmarks using floating action button. To specify whether the document is read-only call `setReadOnly(boolean)`.

## Import and export

It is possible to import and export user bookmarks in JSON format. Typical use case is to save and load the user bookmarks JSON from a server.

The user bookmark JSON is a dictionary with page indices as keys and the bookmark title as the values. For example: `{"0":"Bookmark 1","2":"Bookmark 2"}`. Behaviour is undefined otherwise. Note that the page indices will be 0-indexed similar to XFDF.

{% tabs %}
{% tab title="C#" %}
{% code lineNumbers="true" %}

```csharp
// import
BookmarkManager.ImportPdfBookmarks(PDFViewCtrl, String)
// export
BookmarkManager.ExportPdfBookmarks(PDFDoc)
```

{% endcode %}
{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.apryse.com/xamarin/guides/viewer-components/user-bookmarks-a.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
